//-------------------------------------------------------------------------------------------------
// Capsule2.cpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "Capsule2.hpp"


//-------------------------------------------------------------------------------------------------
// DoMovingDiscsCollide
// 
// Where <this> is disc #1, and <compare> is disc #2.  Each disc is presumed to
//	have started its motion this frame at <_start>, finishing at <_end>.
//-------------------------------------------------------------------------------------------------
/*
bool Capsule2::DoMovingDiscsCollide( const Capsule2& compare )
{
	// NOTE: 'A' refers to "this" object, 'B' refers to the "compare" object.
	// Though _start and _end do not necessarily represent points in time
	//	of a moving disc (which is one application of a capsule), we will
	//	be using that metaphor here for naming purposes and readability.

	/// Calculate motion vectors for both capsules
	const Vector2 motionA( _end - _start );
	const Vector2 motionB( compare._end - compare._start );

	/// Translate the motion vector for A into B's (starting) inertial frame of reference
	const Vector2 motionA_B( motionA - motionB );

	/// Check for special case: no relative motion
	if( motionA_B.IsZero() )
	{
		/// There is no relative motion between the objects; therefore,
		//	they either overlap (collision) or not (no collision).
		const Vector2 displacement( compare._start - _start );
		const float sumOfRadii = _radius + compare._radius;
		const float radiiSquared = sumOfRadii * sumOfRadii;
		return( displacement.CalcLengthSquared() < radiiSquared );
	}

	/// Translate the position of B's start into A's start-coordinate-system
	const Vector2 positionB_A( compare._start - _start );

	/// Reduce B to a point; add B's radius to A's
	const float radiusA_B = _radius + compare._radius;
	if( radiusA_B <= 0.0f )
	{
		/// Both objects are singularities; trivially reject this case
		return false;
	}

	/// Calculate the parametric value t when the A-relative point 'B'
	//	is projected onto A's translated motion line segment
	const float t = (positionB_A | motionA_B) / motionA_B.CalcLengthSquared();

	/// Determine which point on the line segment <motionA_B> is closest to <positionB_A>
	/// and Calculate the distance between the point <positionB_A> and the line segment <motionA_B>
	float distanceSquared;
	if( t <= 0.0f )
	{
		/// <positionB_A> is closest to start point of <motionA_B>
		distanceSquared = positionB_A.CalcLengthSquared();
	}
	else if( t >= 1.0f )
	{
		/// <positionB_A> is closest to end point of <motionA_B>
		distanceSquared = (positionB_A - motionA_B).CalcLengthSquared();
	}
	else
	{
		/// <positionB_A> is closest to some point on <motionA_B>
		const Vector2 pointOnLineSegment( t * motionA_B );
		distanceSquared = (positionB_A - pointOnLineSegment).CalcLengthSquared();
	}

	/// Determine if <positionB_A> is farther from the line than the capsule's radius
	return( distanceSquared < (radiusA_B * radiusA_B) );
}
*/

