
#pragma once

#include "gameCommon.hpp"

class Lights
{
public:

	Lights();
	~Lights();

	void draw();
	void setTexture( Texture* const tex );

	float	m_mapRadiusScale;
	float	m_playerRadiusScale;
	Rgba	m_fogColor;

protected:

	Texture* _attenuationTexture;

	//	for each LightColorGroup
	//		render only to stencil buffer
	//		clear the stencil buffer
	//		for each LightAttenuationGroup in the LightAttenuationGroupMap
	//			bind the LightAttenuationGroup's attenuationTexture
	//			for each LightSource in the LightAttenuationGroup's lights
	//				render a textured quad centered at Light's pos scaled so its edge is at Light's radius
	//		set the LightColorGroup's color
	//		render to color buffer with stencil buffer enabled
	//		draw a non-textured flat-shaded quad over the play field

};