// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.

#pragma once
#include "gameCommon.hpp"
#include "../Engine/Texture.hpp"
#include "MapData.hpp"

class MapDisplay
{
public:

	MapDisplay();
	~MapDisplay();

	void LoadTiles( const std::string tilesetName );
	void Draw( int mapNumber );
	void SetTileDrawColor( MapData& mapData, int tileX, int tileY, const Material& mat );

	Texture* _tileTexture;
	bool m_isDebugDrawingEnabled;

protected:
	
	void _UnloadTiles();

};
