//-------------------------------------------------------------------------------------------------
// TheGame_Update.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
// 
// This source may not be used, modified, or distributed
//  without the express written permission of Brian 'Squirrel' Eiserloh.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGame.hpp"
#include "Particle.hpp"


//-------------------------------------------------------------------------------------------------
// UpdateEverything
// 
// Process input, update entities, run game logic
//-------------------------------------------------------------------------------------------------
void TheGame::UpdateEverything()
{
	Particle::UpdateAll();
	Entity::UpdateEntities();
	m_player->Update();
}


